package java.awt.font;

class TextJustifier
{
    private GlyphJustificationInfo[] info;
    private int start;
    private int limit;
    static boolean DEBUG;
    public static final int MAX_PRIORITY = 3;
    
    TextJustifier(GlyphJustificationInfo[] info, int i, int n) {
        this.info = info;
        this.start = i;
        this.limit = n;
        if (TextJustifier.DEBUG) {
            System.out.println("start: " + i + ", limit: " + n);
            GlyphJustificationInfo glyphJustificationInfo;
            for (; i < n; ++i) {
                glyphJustificationInfo = info[i];
                System.out.println("w: " + glyphJustificationInfo.weight + ", gp: " + glyphJustificationInfo.growPriority + ", gll: " + glyphJustificationInfo.growLeftLimit + ", grl: " + glyphJustificationInfo.growRightLimit);
            }
        }
    }
    
    public float[] justify(float n) {
        float[] array = new float[this.info.length * 2];
        int n2 = n > 0.0f;
        if (TextJustifier.DEBUG) {
            System.out.println("delta: " + n);
        }
        int n3 = -1;
        for (int i = 0; n != 0.0f; ++i) {
            int n4 = i > 3;
            if (!(n4 == 0)) {
                i = n3;
            }
            float f = 0.0f;
            float f2 = 0.0f;
            float f3 = 0.0f;
            for (int j = this.start; j < this.limit; ++j) {
                GlyphJustificationInfo glyphJustificationInfo = this.info[j];
                if ((n2 ? glyphJustificationInfo.growPriority : glyphJustificationInfo.shrinkPriority) == i) {
                    if (n3 == -1) {
                        n3 = i;
                    }
                    if (j != this.start) {
                        f += glyphJustificationInfo.weight;
                        if (!(n2 == 0)) {
                            f2 += glyphJustificationInfo.growLeftLimit;
                            if (glyphJustificationInfo.growAbsorb) {
                                f3 += glyphJustificationInfo.weight;
                            }
                        }
                        else {
                            f2 += glyphJustificationInfo.shrinkLeftLimit;
                            if (glyphJustificationInfo.shrinkAbsorb) {
                                f3 += glyphJustificationInfo.weight;
                            }
                        }
                    }
                    if (j + 1 != this.limit) {
                        f += glyphJustificationInfo.weight;
                        if (!(n2 == 0)) {
                            f2 += glyphJustificationInfo.growRightLimit;
                            if (glyphJustificationInfo.growAbsorb) {
                                f3 += glyphJustificationInfo.weight;
                            }
                        }
                        else {
                            f2 += glyphJustificationInfo.shrinkRightLimit;
                            if (glyphJustificationInfo.shrinkAbsorb) {
                                f3 += glyphJustificationInfo.weight;
                            }
                        }
                    }
                }
            }
            if (n2 == 0) {
                f2 = -f2;
            }
            int n5 = f == 0.0f || (n4 == 0 && n < 0.0f == n < f2);
            int n6 = n5 && f3 > 0.0f;
            float f4 = n / f;
            float f5 = 0.0f;
            if (n5 && f3 > 0.0f) {
                f5 = (n - f2) / f3;
            }
            if (TextJustifier.DEBUG) {
                System.out.println("pass: " + i + ", d: " + n + ", l: " + f2 + ", w: " + f + ", aw: " + f3 + ", wd: " + f4 + ", wa: " + f5 + ", hit: " + (n5 ? "y" : "n"));
            }
            int n7 = this.start * 2;
            for (int k = this.start; k < this.limit; ++k) {
                GlyphJustificationInfo glyphJustificationInfo2 = this.info[k];
                if ((n2 ? glyphJustificationInfo2.growPriority : glyphJustificationInfo2.shrinkPriority) == i) {
                    if (k != this.start) {
                        float n8;
                        if (!(n5 == 0)) {
                            n8 = (n2 ? glyphJustificationInfo2.growLeftLimit : (-glyphJustificationInfo2.shrinkLeftLimit));
                            if (!(n6 == 0)) {
                                n8 += glyphJustificationInfo2.weight * f5;
                            }
                        }
                        else {
                            n8 = glyphJustificationInfo2.weight * f4;
                        }
                        int n9 = n7;
                        array[n9] += n8;
                    }
                    ++n7;
                    if (k + 1 != this.limit) {
                        float n10;
                        if (!(n5 == 0)) {
                            n10 = (n2 ? glyphJustificationInfo2.growRightLimit : (-glyphJustificationInfo2.shrinkRightLimit));
                            if (!(n6 == 0)) {
                                n10 += glyphJustificationInfo2.weight * f5;
                            }
                        }
                        else {
                            n10 = glyphJustificationInfo2.weight * f4;
                        }
                        int n11 = n7;
                        array[n11] += n10;
                    }
                    ++n7;
                }
                else {
                    n7 += 2;
                }
            }
            if (n4 == 0 && n5 && n6 == 0) {
                n -= f2;
            }
            else {
                n = 0.0f;
            }
        }
        if (TextJustifier.DEBUG) {
            float f6 = 0.0f;
            for (int l = 0; l < array.length; ++l) {
                f6 += array[l];
                System.out.print(array[l] + ", ");
                if (l % 20 == 9) {
                    System.out.println();
                }
            }
            System.out.println("\ntotal: " + f6);
            System.out.println();
            return array;
        }
        return array;
    }
    
    static {
        TextJustifier.DEBUG = false;
    }
}
